package de.hft.stuttgart.citydoctor2.healer.genetic;

import java.util.List;
import java.util.Random;

import de.hft.stuttgart.citydoctor2.check.HealingMethod;
import de.hft.stuttgart.citydoctor2.healer.HealingPlan;

public class RandomSwitchMutation implements Mutation<HealingPlan> {
	
	private Random r = new Random();

	@Override
	public HealingPlan mutate(HealingPlan individual) {
		double percentage = r.nextDouble();
		if (percentage > 0.7) {
			// mutate 30% of the time
			List<HealingMethod> healingMethods = individual.getHealingMethods();
			int index = r.nextInt(healingMethods.size() - 1);
			HealingMethod temp = healingMethods.get(index + 1);
			healingMethods.set(index + 1, healingMethods.get(index));
			healingMethods.set(index, temp);
		}
		return individual;
	}
	
	

}
